unit demoisoproblemu;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    CheckBox1: TCheckBox;
    PaintBox1: TPaintBox;
    procedure FormResize(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    xmargin, ymargin, axisheight, axiswidth: integer;
    windowaspect, minx, miny, maxx, maxy, factx, facty: double;

    procedure scalexy(x, y: double; var gx, gy: integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  xmargin := 10; { margins }
  ymargin := 20;
  minx := 0; { define min,max for axes }
  miny := 0;
  maxy := 2;
  maxx := 4;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  PaintBox1.Invalidate;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  PaintBox1.Invalidate;
end;

procedure TForm1.scalexy(x, y: double; var gx, gy: integer);
begin  { scale data to pixels }
  gx := xmargin + Round(factx * (x - minx));
  gy := ymargin + Round(facty * (maxy - y));
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var
  gx, gy: integer;
  range_x, range_y, DataAspectRatio, WindowAspectRatio: double;
begin  { scale if iso else just plot }
  range_x := maxx - minx;
  range_y := maxy - miny;
  factx := (PaintBox1.Width - 2 * xmargin) / range_x;
  facty := (PaintBox1.Height - 2 * ymargin) / range_y;
  DataAspectRatio := range_y / range_x;
  WindowAspectRatio := (PaintBox1.Height - 2 * ymargin) /
    (PaintBox1.Width - 2 * xmargin);
  if CheckBox1.checked then
  begin
    if (DataAspectRatio <= WindowAspectRatio) then
      facty := factx
    else
      factx := facty;
  end;

  with PaintBox1.Canvas do {draw axes allowing for margins}
  begin
    scalexy(0, 0, gx, gy);
    moveto(gx, gy);
    scalexy(maxx, 0, gx, gy);
    lineto(gx, gy);
    scalexy(0, 0, gx, gy);
    moveto(gx, gy);
    scalexy(0, maxy, gx, gy);
    lineto(gx, gy);
  end;
end;

end.
